Rust Search

Find the best content on Rust, curated by the community; a search engine for Rustaceans.
rustc-dev-guide.rust-lang.org
Mastering @rustbot @rustbot (also known as triagebot) is a utility robot that is mostly used to allow any contributor to achieve certain tasks that would normally require GitHub membership to the rust-lang organization. Its most interesting...
Guide to Rustc Development Book 2024-01-01 ~2 min read
rustc-dev-guide.rust-lang.org
Walkthrough: a typical contribution There are a lot of ways to contribute to the Rust compiler, including fixing bugs, improving performance, helping design features, providing feedback on existing features, etc. This chapter does not claim...
Guide to Rustc Development Book 2024-01-01 ~10 min read
rustc-dev-guide.rust-lang.org
Implementing new language features When you want to implement a new significant feature in the compiler, you need to go through this process to make sure everything goes smoothly. NOTE: This section is for language features, not library fea...
Guide to Rustc Development Book 2024-01-01 ~9 min read
rustc-dev-guide.rust-lang.org
Stability guarantees This page gives an overview of our stability guarantees. RFCs • RFC 1105 api evolution • RFC 1122 language semver Blog posts • Stability as a Deliverable rustc-dev-guide links • Stabilizing library features • Stabilizin...
Guide to Rustc Development Book 2024-01-01 ~1 min read
rustc-dev-guide.rust-lang.org
Stability attributes This section is about the stability attributes and schemes that allow stable APIs to use unstable APIs internally in the rustc standard library. NOTE: this section is for library features, not language features. For ins...
Guide to Rustc Development Book 2024-01-01 ~7 min read
rustc-dev-guide.rust-lang.org
Request for stabilization NOTE: This page is about stabilizing language features. For stabilizing library features, see Stabilizing a library feature. Once an unstable feature has been well-tested with no outstanding concerns, anyone may pu...
Guide to Rustc Development Book 2024-01-01 ~6 min read
rustc-dev-guide.rust-lang.org
Stabilization report template What is this? This is a template for stabilization reports of language features. The questions aim to solicit the details most often needed. These details help reviewers to identify potential problems upfront....
Guide to Rustc Development Book 2024-01-01 ~5 min read
rustc-dev-guide.rust-lang.org
Feature gates This chapter is intended to provide basic help for adding, removing, and modifying feature gates. For how rustc enforces and checks feature gates in the compiler pipeline, see Feature Gate Checking. Note that this is specific...
Guide to Rustc Development Book 2024-01-01 ~1 min read
rustc-dev-guide.rust-lang.org
Coding conventions This chapter covers formatting, coding for correctness, using crates from crates.io, and some tips on structuring your PR for easy review. Formatting and the tidy script rustc is moving towards the Rust standard coding st...
Guide to Rustc Development Book 2024-01-01 ~4 min read
rustc-dev-guide.rust-lang.org
Procedures for breaking changes This page defines the best practices procedure for making bug fixes or soundness corrections in the compiler that can cause existing code to stop compiling. This text is based on RFC 1589. Motivation From tim...
Guide to Rustc Development Book 2024-01-01 ~9 min read
rustc-dev-guide.rust-lang.org
Using external repositories The rust-lang/rust git repository depends on several other repos in the rust-lang organization. There are three main ways we use dependencies: 1. As a Cargo dependency through crates.io (e.g. rustc-rayon) 2. As a...
Guide to Rustc Development Book 2024-01-01 ~5 min read
rustc-dev-guide.rust-lang.org
Fuzzing For the purposes of this guide, fuzzing is any testing methodology that involves compiling a wide variety of programs in an attempt to uncover bugs in rustc. Fuzzing is often used to find internal compiler errors (ICEs). Fuzzing can...
Guide to Rustc Development Book 2024-01-01 ~4 min read
rustc-dev-guide.rust-lang.org
Notification groups The notification groups are an easy way to help out with rustc in a "piece-meal" fashion, without committing to a larger project. Notification groups are easy to join (just submit a PR!) and joining does not entail any p...
Guide to Rustc Development Book 2024-01-01 ~2 min read
rustc-dev-guide.rust-lang.org
Apple notification group GitHub Labels: O-macos, O-ios, O-tvos, O-watchos and O-visionos Ping command: @rustbot ping apple This list will be used to ask for help both in diagnosing and testing Apple-related issues as well as suggestions on...
Guide to Rustc Development Book 2024-01-01 ~1 min read
rustc-dev-guide.rust-lang.org
ARM notification group GitHub Label: O-ARM Ping command: @rustbot ping arm This list will be used to ask for help both in diagnosing and testing ARM-related issues as well as suggestions on how to resolve interesting questions regarding our...
Guide to Rustc Development Book 2024-01-01 ~1 min read
rustc-dev-guide.rust-lang.org
Emscripten notification group GitHub Label: O-emscripten Ping command: @rustbot ping emscripten This list will be used to ask for help both in diagnosing and testing Emscripten-related issues as well as suggestions on how to resolve interes...
Guide to Rustc Development Book 2024-01-01 ~1 min read
rustc-dev-guide.rust-lang.org
Fuchsia notification group GitHub Label: O-fuchsia Ping command: @rustbot ping fuchsia This list will be used to notify Fuchsia maintainers when the compiler or the standard library changes in a way that would break the Fuchsia integration.
Guide to Rustc Development Book 2024-01-01 ~1 min read
rustc-dev-guide.rust-lang.org
LoongArch notification group GitHub Label: O-loongarch Ping command: @rustbot ping loongarch This list will be used to ask for help both in diagnosing and testing LoongArch-related issues as well as suggestions on how to resolve interesting...
Guide to Rustc Development Book 2024-01-01 ~1 min read
rustc-dev-guide.rust-lang.org
RISC-V notification group GitHub Label: O-riscv Ping command: @rustbot ping risc-v This list will be used to ask for help both in diagnosing and testing RISC-V-related issues as well as suggestions on how to resolve interesting questions re...
Guide to Rustc Development Book 2024-01-01 ~1 min read
rustc-dev-guide.rust-lang.org
Rust for Linux notification group GitHub Label: A-rust-for-linux Ping command: @rustbot ping rfl This list will be used to notify Rust for Linux (RfL) maintainers when the compiler or the standard library changes in a way that would break R...
Guide to Rustc Development Book 2024-01-01 ~1 min read
"After all, Rust only became as good as it is by going through a rather drastic transformation. At one point it had a GC and Green Threads, famously. T..."

Search tips

Type anything to search across articles, videos (including conference talks), podcasts, research, crates, and Rust API documentation. These operators give you finer control — click an example to try it.

Find pages containing all your words. Pages where the words appear together rank higher.
Quote part of your query to keep those words together as an exact phrase within a larger search.
Wrap the whole query in quotes for a verbatim search that matches text exactly, punctuation and all — perfect for Rust syntax. Needs at least 3 characters.
Put ! first to open the top result immediately. Quote the whole query for a literal leading bang, as in '!Send'. Bangs elsewhere, such as println!, stay literal. Browser and launcher shortcuts can invoke this directly. See search integrations.
Limit results to a single site. Works on its own () too. One site: per search.

Use the tabs and filters above the results to narrow by content type, publication year, and sort order.